%   Fresnel coefficient test bench
clear all;
close all;

% ==== part A ====

oldpath = path;
%path(oldpath,'/home/mfertig/Dokumente/matlab/OP_WS1617/Exercise_ABCD_matrix');
path(oldpath,'./');


% ==== part B ====

X = 0.1; % [m]
n = 10; % [-]
dx = X/n % [m]

SCENE = { 'prop' 'plane' 'prop' };

D1 = 0.05; % [m]
M1 = abcd_propagation(dx)

ni = 1;
nt = 3.4;
M2 = abcd_plane(ni,nt)

D2 = 0.05; % [m]
M3 = abcd_propagation(dx)

theta_deg = -17
theta_rad = theta_deg*pi/180
tan_theta = tan(theta_rad)
dtan_percent = round((tan_theta - theta_rad)/tan_theta *100,2)

dmax = 3;
if dtan_percent>dmax
    sprintf('Attention! Deviation greater %d percent!',dmax)
    pause;
end

yo = 0.02;
dyo = theta_rad;
obj = [ yo ; dyo ];

sprintf('Theta = %d [deg]',round(180/pi*atan(dyo/dx),2))

ix = 0:1:n-1;
X = ix*dx;
Z = zeros(1,n);

for i=1:n
    
    Z(i) = obj(1);
    
    if ((i*dx)<D1)
        
        img = M1*obj
                
    end
    if ((i*dx)==D1)
        
        img = M2*M1*obj
        
    end
    if ((i*dx)>D2)
        
        img = M3*obj
                
    end
    
    obj = img;
    
end

figure(100);hold on;
plot(X,zeros(n),'r:');
plot(X,Z); ylim([-abs(2*yo) abs(2*yo)]); xlim([min(X) max(X)]);
title(sprintf('Transformation at plane interface at d=%.2d \\newline for n_i=%d, n_t=%1.2d and \\theta_i=%.2d [deg]',D1,ni,nt,theta_deg));

% ==== part E ====

X = 0.1; % [m]
n = 10; % [-]
dx = X/n % [m]

SCENE = { 'prop' 'lens' 'prop' };

D1 = 0.05; % [m]
M1 = abcd_propagation(dx)

f = 0.05
M2 = abcd_lens(f)

D2 = f; % [m]
M3 = abcd_propagation(dx)

theta_deg = 10
theta_rad = theta_deg*pi/180
tan_theta = tan(theta_rad)
dtan_percent = round((tan_theta - theta_rad)/tan_theta *100,2)

dmax = 3;
if dtan_percent>dmax
    sprintf('Attention! Deviation greater %d percent!',dmax)
    pause;
end

yo_n = 10;
yo_min = -0.02;
yo_max = 0.02;
yo = yo_min:(yo_max-yo_min)/yo_n:yo_max;

dyo = theta_rad;

sprintf('Theta = %d [deg]',round(180/pi*atan(dyo/dx),2))

ix = 0:1:n-1;
X = ix*dx;
Z = zeros(1,n);

for j=1:size(yo,2);
    
    obj = [ yo(j) ; dyo ];

    for i=1:n
        
        Z(i) = obj(1);
        
        if ((i*dx)<D1)
            
            img = M1*obj;
            
        end
        if ((i*dx)==D1)
            
            img = M3*M2*obj;
            
        end
        if ((i*dx)>D2)
            
            img = M3*obj;
            
        end
        
        obj = img;
        
    end
    
    figure(200);hold on;
    plot(X,zeros(n),'r:');
    if 1==j
        plot(X,Z,'g'); ylim([-abs(2*min(yo)) abs(2*max(yo))]); xlim([min(X) max(X)]);
    else
        plot(X,Z,'b'); ylim([-abs(2*min(yo)) abs(2*max(yo))]); xlim([min(X) max(X)]);
    end
   
end

figure(200);hold on; title(sprintf('Propagation through a lens with \\newline focal length %.2d at \\theta_i=%.2d [deg]',f,theta_deg));

% ==== part E.2 ====

X = 0.10; % [m]
n = 10; % [-]
dx = X/n % [m]

SCENE = { 'prop' 'lens' 'prop' };

D1 = 0.05; % [m]
M1 = abcd_propagation(dx)

f = 0.05
M2 = abcd_lens(f)

D2 = f; % [m]
M3 = abcd_propagation(dx)

theta_deg = -10:4:10;
theta_rad = theta_deg*pi/180;
tan_theta = tan(theta_rad);
dtan_percent = max(round((tan_theta - theta_rad)/tan_theta *100,2))

dmax = 3;
if dtan_percent>dmax
    sprintf('Attention! Deviation greater %d percent!',dmax)
    pause;
end

yo_n = 3;
yo_min = -0.02;
yo_max = 0.02;
yo = yo_min:(yo_max-yo_min)/yo_n:yo_max;
dyo = theta_rad;

ix = 0:1:n-1;
X = ix*dx;
Z = zeros(1,n);

for k=1:size(yo,2);
    
    for j=1:size(dyo,2);
        
        % sprintf('Theta = %d [deg]',round(180/pi*atan(dyo(j)/dx),2))
        
        obj = [ yo(k) ; dyo(j) ];
        
        for i=1:n
            
            Z(i) = obj(1);
            
            if ((i*dx)<D1)
                
                img = M1*obj;
                
            end
            if ((i*dx)==D1)
                
                img = M3*M2*obj;
                
            end
            if ((i*dx)>D1)
                
                img = M3*obj;
                
            end
            
            obj = img;
            
        end
        
        figure(300);hold on;
        plot(X,zeros(n),'r:');
        if 1==j 
            plot(X,Z,'g'); ylim([-abs(2*min(yo)) abs(2*max(yo))]); xlim([min(X) max(X)]);
        else
            plot(X,Z,'b'); ylim([-abs(2*min(yo)) abs(2*max(yo))]); xlim([min(X) max(X)]);
        end
        
    end
    
end

figure(300);hold on; title(sprintf('Propagation through a lens with \\newline focal length %.2d and angles between %.2d [deg] and %.2d [deg]',f,min(theta_deg),max(theta_deg)));

% ==== FUN ====

X = 0.25; % [m]
n = 25; % [-]
dx = X/n % [m]

SCENE = { 'prop' 'lens' 'prop' 'lens' 'prop' };

D1 = 0.05; % [m]
M1 = abcd_propagation(dx);

% ==== LENSES ====
f1 = -0.05;
M2 = abcd_lens(f1)

f2 = 0.05;
M4 = abcd_lens(f2)

% ==== PROPAGATION ====
D1 = abs(f1); % [m]
M1 = abcd_propagation(dx);

D2 = abs(f2)+abs(f1); % [m]
M3 = abcd_propagation(dx);

D3 = abs(f2); % [m]
M5 = abcd_propagation(dx);

% ==== SEGMENTS ====
SEG1 = round(D1,3);
SEG2 = round(D1+D2,3);
SEG3 = round(D1+D2+D3,3);

%theta_deg = -5:1:5;
theta_deg = -5:2.5:5;
%theta_deg = -5;
theta_rad = theta_deg*pi/180;
tan_theta = tan(theta_rad);
if size(theta_deg,2)>1
    if 0~=max(tan_theta)
        dtan_percent = max(round((tan_theta - theta_rad)/tan_theta *100,2)) 
    end
else
    if 0~=tan_theta
        dtan_percent =    (round((tan_theta - theta_rad)/tan_theta *100,2))     
    end
end

dmax = 3;
if dtan_percent>dmax
    sprintf('Attention! Deviation greater %d percent!',dmax)
    pause;
end

yo_n = 2;
yo_min = -0.02;
yo_max = 0.02;
yo = yo_min:(yo_max-yo_min)/yo_n:yo_max;
dyo = theta_rad;

ix = 0:1:n-1;
X = ix*dx;
Z = zeros(1,n);

BOOK = zeros(1,size(X,2));

for k=1:size(yo,2);
    
    for j=1:size(dyo,2);
        
        %sprintf('Theta = %d [deg]',round(180/pi*atan(dyo(j)/dx),2))
        
        obj = [ yo(k) ; dyo(j) ];
        
        for i=1:n
            
            xpos = round(i*dx,3);
            
            Z(i) = obj(1);
            
            if (xpos<SEG1) % propagation
                
                BOOK(i) = 1;
                img = M1*obj;
                
            end
            if (xpos==SEG1) % lens 1
                
               %sprintf('Lens 1')
               BOOK(i) = 21;
               img = M2*M1*obj;
                
            end
            if ((xpos>SEG1) & (xpos<SEG2))  % propagation

                BOOK(i) = 3;
                img = M3*obj;

            end
            if (xpos==SEG2) % lens 2
                 
                 sprintf('Lens 2')
                 BOOK(i) = 43;
                 img = M4*M3*obj;
                 
             end
%             if ((xpos>SEG2) & (xpos<SEG3)) % propagation
%                 
%                 BOOK(i) = 5;
%                 img = M5*obj;
%                 
%             end
            
            obj = img;
            
        end
        
        figure(400);hold on;
        plot(X,zeros(n),'r:');
        if 1==j 
            plot(X,Z,'g'); ylim([-abs(5*min(yo)) abs(5*max(yo))]); xlim([min(X) max(X)]);
        else
            plot(X,Z,'b'); ylim([-abs(5*min(yo)) abs(5*max(yo))]); xlim([min(X) max(X)]);
        end
        
    end
    
end

figure(400);hold on; title(sprintf('Propagation through a lens with \\newline f1 = %.2d and f2 = %.2d ',f1,f2));

% ==== RESET PATH ===

path(oldpath);
